{$APPTYPE CONSOLE}
{$MAXSTACKSIZE 32000000}

type TInputList = record car, num: integer; end;
     TRaceList = record lap, car, LastCross: integer; end;

const MaxN = 1000*1000 + 1;

var InputList: array[1..MaxN] of TInputList;
    RaceList: array[1..MaxN] of TRaceList;
    x: TInputList; y: TRaceList;
    i, j, k, l, n, m, t: integer;
    fi, fo: text;

procedure swap(var a, b: integer);
begin
  t := a; a := b; b := t;
end;

procedure QSortInputList(l, r: integer);
var i, j: integer;
begin
  x := InputList[l + random(r-l)];
  i := l; j := r;
  repeat
    while (InputList[i].car < x.car) or
          ((InputList[i].car = x.car) and (InputList[i].num < x.num)) do inc(i);
    while (InputList[j].car > x.car) or
          ((InputList[j].car = x.car) and (InputList[j].num > x.num)) do dec(j);
    if i <= j then
      begin
        swap(InputList[i].car, InputList[j].car);
        swap(InputList[i].num, InputList[j].num);
        inc(i); dec(j); 
      end;
  until i > j;
  if l < j then QSortInputList(l, j);
  if i < r then QSortInputList(i, r);
end;

procedure QSortRaceList(l, r: integer);
var i, j: integer;
begin
  y := RaceList[l + random(r-l)];
  i := l; j := r;
  repeat
    while (RaceList[i].lap > y.lap) or
          ((RaceList[i].lap = y.lap) and (RaceList[i].LastCross < y.LastCross)) do inc(i);
    while (RaceList[j].lap < y.lap) or
          ((RaceList[j].lap = y.lap) and (RaceList[j].LastCross > y.LastCross)) do dec(j);
    if i <= j then
      begin
        swap(RaceList[i].car, RaceList[j].car);
        swap(RaceList[i].lap, RaceList[j].lap);
        swap(RaceList[i].LastCross, RaceList[j].LastCross);
        inc(i); dec(j); 
      end;
  until i > j;
  if l < j then QSortRaceList(l, j);
  if i < r then QSortRaceList(i, r);
end;

begin
  randomize;
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  read(fi, n);
  for i := 1 to n do
    begin
      read(fi, InputList[i].car);
      InputList[i].num := i;
    end;
  inc(n);
  InputList[n].car := MaxInt;
  QSortInputList(1, n);
  j := 0; k := 1;
  for i := 2 to n do
    begin
      if InputList[i].car <> InputList[i-1].car then
        begin
          inc(j);
          RaceList[j].car := InputList[i-1].car;
          RaceList[j].lap := k;
          RaceList[j].LastCross := InputList[i-1].num;
          k := 1;
        end
      else
        inc(k);
    end;
  QSortRaceList(1, j);
  for i := 1 to j do
    write(fo, RaceList[i].car, ' ');
  CloseFile(fi);
  CloseFile(fo);
end.